// ===========================================================================
//	CActiveXDocument.h			   1996 Microsoft Corporation. All rights reserved.
// ===========================================================================

#pragma once

#include <LSingleDoc.h>
#include "CContainer.h"

class CActiveXView;

class CActiveXDocument : public CContainer,
						public LSingleDoc
{
public:
							CActiveXDocument( LCommander *inSuper, FSSpec *inFileSpec );
							~CActiveXDocument(void);

	virtual Boolean			IsModified();
	
	virtual void			DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void			DoSave();
	virtual void			DoRevert();

	ErrorCode RequestFocus ( CActiveXView* theActiveXView, Boolean inAcquire, FocusSet inFocus);

	// **** IContainer methods overrides ***
	STDMETHOD_				(ULONG, Release)(void);
	static CActiveXDocument	*GetDefaultContainer(void) { return sDefaultContainer; };

protected:
	CActiveXView *			mActiveXView[kActiveXViewCount];
	CActiveXView *			mFocusView;
	CActiveXView *			mModalFocusView;

	void					NameNewDoc();
	void					OpenFile( FSSpec &inFileSpec );

	virtual void			FindCommandStatus( CommandT inCommand,
								Boolean &outEnabled, Boolean &outUsesMark,
								Char16 &outMark, Str255 outName );

private:
	static CActiveXDocument	*sDefaultContainer;
};