// ===========================================================================
//	CActiveXView.h				  1996 Microsoft Corporation. All rights reserved..
// ===========================================================================

#ifndef _H_CActiveXShadowView
#define _H_CActiveXShadowView
#pragma once

#include <LView.h>
#include <LCommander.h>
#include <LPeriodical.h>
#include <LAttachment.h>

#include "HEADERS.H"

class	CActiveXView;
class	CActiveXShadowView : public LView,
						public LCommander,
						public LDragAndDrop
{

public:
	enum { class_ID = 'actX' };
	static CActiveXShadowView*	CreateActiveXShadowViewStream(LStream *inStream);

						CActiveXShadowView(void);
						CActiveXShadowView(LStream *inStreamP);
						~CActiveXShadowView(void);

	// **** LView method overrides ****
	virtual void		Click(SMouseDownEvent &inMouseDown);
//	these are tentative View Class Overrides
	virtual void		ResizeFrameBy(Int16 inWidthDelta, Int16 inHeightDelta, Boolean inRefresh);
	virtual void		MoveBy(Int32 inHorizDelta, Int32 inVertDelta, Boolean inRefresh);
	virtual void		AdaptToNewSurroundings(void);
	virtual void		AdaptToSuperFrameSize(Int32 inSurrWidthDelta, Int32 inSurrHeightDelta, Boolean inRefresh);
	virtual void		ScrollImageBy(Int32 inLeftDelta, Int32 inTopDelta, Boolean inRefresh);
	virtual void		ResizeImageBy(Int32 inWidthDelta, Int32 inHeightDelta, Boolean inRefresh);
//	end tentative

	// **** LCommander method overrides ****
	virtual void		DoEvent(EventRecord *inEvent, Boolean *outPassEventUp, Boolean *outRemoveAttachment);

	// **** CActiveXShadowView methods ****
	void				SetMasterView(CActiveXView *inMasterView);

protected:
	static	void		FindMasterView(CActiveXShadowView* inView);
	virtual void		DrawSelf();

	//	Drag and Drop functions
	virtual Boolean		ItemIsAcceptable( DragReference inDragRef, ItemReference inItemRef );
	virtual void		ReceiveDragItem( DragReference inDragRef, DragAttributes inDragAttrs,
							ItemReference inItemRef, Rect &inItemBounds );


private:
	CActiveXView*		mMasterView;
	Int16				mMasterViewID;
	Boolean8			mContextDirty;
};

#endif